###############################################################################
# MultiPart.pl                                                                #
###############################################################################

sub ParseMultipart {
	if (fopen(FILE, "$vardir/maxattachsize.txt"))
	{
		my $maxsizeattach = <FILE>;
		fclose(FILE);
		if ($maxsizeattach*1024 < $ENV{CONTENT_LENGTH})
		{
			print "Status: 413 Request Entity Too Large\n";
			print "Content-Type: text/html\n\n";
			print "<html><head><title>413 Request Entity Too Large</title></head><body><h2>Request not processed</h2><strong>413 Request Entity Too Large</strong></body></html>";
			exit;
		}
	}
	
	if ($ENV{CONTENT_TYPE} !~ /boundary=(\S+)$/) {
		print "Status: 400 Bad Request\n";
		print "Content-Type: text/html\n\n";
		print "<html><head><title>400 Bad Request</title></head><body><h2>Request not processed</h2><strong>400 Bad Request</strong></body></html>";
		exit;
	}
	
	my $boundary = $1;

	binmode(STDIN);
	read(STDIN, my $input, $ENV{CONTENT_LENGTH});
	
	while ($input =~ /(.*?)(?:\015?\012)?-*\Q$boundary\E-*[\015\012]*/osg) {
		my $data = $1;
		if ($data =~ /[Cc]ontent-[Dd]isposition: ([^\015\012]+)\015?\012  # Disposition
				 (?:[A-Za-z].*?(?:\015?\012){2})?                    # Headers
				 (?:\015?\012)?                                      # End
				 (.*)                                                # Other Data
				/xs) {
			(my $disposition, $data) = ($1, $2);

			my ($name) = $disposition =~ /name="([^"]+)"/;
			
			$FORM{$name} = $data;
			
			$filename = $1 if $name eq 'file' && $disposition =~ /filename="(.*)"/;
		 }
	}
}

1;
