<id>
Removing CGI.pm (with file_attachment.mod installed)
</id>

<version>
1.0_fa
</version>

<mod info>
This mod replaces CGI.pm to save server resources. This version is to be used if your forum has the file attachment mod installed. It has been tested with file_attachment.mod version 2.3.

You should restrict the maximum attachment size when using this mod. It should be no more then 1024 kb (the less the better) as the whole form data is parsed in memory.
</mod info>

<author>
Trevize
</author>

<homepage>
http://www.gtchat.de
</homepage>

<edit file>
YaBB.pl
</edit file>

<search for>
use CGI qw(header cookie);	# so we can use the header and cookie printing
use CGI qw/:standard/; 
$CGI::HEADERS_ONCE = 1;	# Kill redundant headers
</search for>

<replace>
sub header {
	my %params = @_;

	my $ret = "";
	if ($params{'-status'}) {
		if ($yyIIS) {
 			$ret .= "HTTP/1.0 $params{'-status'}\n";
		} else {
			$ret .= "Status: $params{'-status'}\n";
		}
	}
	if ($params{'-cookie'}) {
		$ret .= "Set-Cookie: $_\n" foreach (@{$params{'-cookie'}});
	}
	foreach my $key (keys %params) {
		$ret .= "$key: $params{$key}\n" if $key =~ /^[A-Z]/;
	}
	$params{'-charset'} = "; charset=$params{'-charset'}" if $params{'-charset'};
	$ret .= "Content-Type: text/html$params{'-charset'}\n\n";
	return $ret;
}

sub cookie {
	my %params = @_;
	
	if ($params{'-expires'} =~ /\+(\d+)m/) {
		my ($sec,$min,$hour,$mday,$mon,$year,$wday) = gmtime(time + $1*60);

		$year += 1900;
		$mon = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec)[$mon];
		$wday = qw(Sun Mon Tue Wed Thu Fri Sat)[$wday];
		
		$params{'-expires'} = sprintf("%s, %02i-%s-%04i %02i:%02i:%02i GMT", $wday, $mday, $mon, $year, $hour, $min, $sec);
	}
	
	$params{'-path'} = " path=$params{'-path'};" if $params{'-path'};
	$params{'-expires'} = " expires=$params{'-expires'};" if $params{'-expires'};

	return "$params{'-name'}=$params{'-value'};$params{'-path'}$params{'-expires'}";
}
</replace>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
	my $query = new CGI;
	if($ENV{QUERY_STRING} =~ m~;~) { @pairs = split(/;/, $ENV{QUERY_STRING}); }
	else { @pairs = split(/&/, $ENV{QUERY_STRING}); }
	foreach $pair (@pairs) {
		  ($name,$value) = split(/=/, $pair);
		  $name =~ tr/+/ /;
		  $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		  $value =~ tr/+/ /;
		  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		  $value =~ s/<!--(.|\n)*-->//g;
		  $INFO{$name} = $value;
	}
	my (@keylist) = sort($query->param());
	foreach $key (@keylist) {
		if ($query->param('file')) {
			$filename = $query->param('file');
			$postsize -= length($query->param('file'));
			$tmpfile = $query->tmpFileName($filename);
		}
	
		$postsize += length($query->param($key));
		# may be dealing with multiple values; need to join with comma
		$value = join(', ', $query->param($key));
		$FORM{$key} = $value;
	}
</search for>

<replace>
	sub split_string
	{
		my ($string, $hash, $altdelim) = @_;

		if($altdelim && $$string =~ m~;~) { @pairs = split(/;/, $$string); }
		else { @pairs = split(/&/, $$string); }
		foreach $pair (@pairs) {
			($name,$value) = split(/=/, $pair);
			$name =~ tr/+/ /;
			$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			$value =~ tr/+/ /;
			$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			if (exists($hash->{$name})) {
				$hash->{$name} .= ", $value";
			} else {
				$hash->{$name} = $value;
			}
		}
	}
	split_string(\$ENV{QUERY_STRING}, \%INFO, 1);
	if ($ENV{REQUEST_METHOD} eq 'POST')
	{
		if ($ENV{CONTENT_TYPE} =~ /multipart\/form-data/)
		{
			require "$sourcedir/Multipart.pl";
			ParseMultipart();
		}
		else
		{
			read(STDIN, my $input, $ENV{CONTENT_LENGTH});
			split_string(\$input, \%FORM) 
		}
	}
</replace>

<search for>
sub clear_temp {
	if($filename) {
		close($filename);
	}
	if (-e $tmpfile && $tmpfile ne '')  {
		close($tmpfile);
		unlink $tmpfile || &fatal_error("Error deleting tempfile '$tmp': $!\n");
	}
}
</search for>

<replace>
sub clear_temp {
}
</replace>

<edit file>
Sources/Post.pl
</edit file>

<search for>
$filesize = $ENV{'CONTENT_LENGTH'} - $postsize;
</search for>

<replace>
$filesize = length($FORM{'file'});
</replace>

<search for>
if ($upload_okay == 1) {
	if($servertype == 0) {
		fopen(AMT, ">$write_file")||&write_error("$fatxt{'19'} $write_file. $!");
		binmode AMT;
		# binmode is for windows only. Ignored by unix
		while ($bytesread=read($filename,$buffer,1024)) { print AMT $buffer; }
		fclose(AMT);	
		chmod (0666, "$write_file");
		close($filename);
		1;
	} elsif ($servertype == 1) {
		close($filename);
		rename $tmpfile, $write_file || &write_error("Error renaming '$tmpfile' to '$write_file'!");
		1;
	}
&clear_temp;
}
</search for>

<replace>
if ($upload_okay == 1) {
	fopen(AMT, ">$write_file")||&write_error("$fatxt{'19'} $write_file. $!");
	binmode AMT;
	# binmode is for windows only. Ignored by unix
	print AMT $FORM{'file'};
	fclose(AMT);
	chmod (0666, $write_file);
}
</replace>
